

% SIN_Forecasting_2_Results_of

% 2. Forecasting Results

function y_FOR_Results = SIN_EACD_11_Forecasting_2_Results_of(Data_Matrix, i_0)

% Input

H = 60;                                 % Forecasting horizon
SIN_Intervals = load('SIN_Intervals');  % Interval selection
% SIN_EACD_11_Critical_Values_5_Test_Statistics.m
y = Data_Matrix(:, 26);                 % Order flow
s = ones(size(Data_Matrix(:, 28)));     % Seasonal factor for order flow, all ones
y_observed = Data_Matrix(:, 26);        % Order flow

% Programme Code

y_T = SIN_EACD_11_Forecasting_1_Test_Statistics_of(y(i_0 - 359 : i_0, 1));
y_k_hat = sum(y_T < 100) - 1;
y_n_hat = SIN_Intervals(y_k_hat + 1, 2);
y_theta_hat = SIN_EACD_11_Estimation(y(i_0 - y_n_hat + 1 : i_0, 1));
y_mut = ones(360 + H, 1);
for t = 2 : 1 : 361
  y_mut(t, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y(t + i_0 - 361, 1) + y_theta_hat(3, 1) * y_mut(t - 1, 1);
end
y_for = zeros(H, 1);
y_for(1, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y(i_0 - 359, 1) + y_theta_hat(3, 1) * y_mut(360, 1);
for h = 2 : 1 : H
  y_mut(360 + h, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y_for(h - 1, 1) + y_theta_hat(3, 1) * y_mut(360 + h - 1, 1);
  y_for(h, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y_for(h - 1, 1) + y_theta_hat(3, 1) * y_mut(360 + h - 1, 1);
end
y_true = y_observed(i_0 - 359 : i_0 + 60, 1);
y_predicted = vertcat(y_mut(1 : 360, 1) .* s(i_0 - 359 : i_0, 1), y_for .* s(i_0 + 1 : i_0 + 60, 1));

% Output

y_FOR_Results = vertcat(Data_Matrix(i_0, 1), Data_Matrix(i_0, 2), Data_Matrix(i_0 + 60, 1), Data_Matrix(i_0 + 60, 2), y_k_hat, y_n_hat, y_theta_hat, y_T, y_true, y_predicted);

end


